<?php
// $Id: opengrid_grid_assembler.inc,v 1.5 2010/08/14 00:25:31 mauro72 Exp $
function opengrid_grid_settings_vars($vars){
  global $theme_key;
  $settings = theme_get_settings($theme_key); 
  
  if ($vars['right'] && $vars['left']) {
    $new_vars = layout_grid_assembler('both_sidebars_layout',$settings);
  }
  if($vars['right'] && !$vars['left']) {
    $new_vars = layout_grid_assembler('second_sidebar_layout',$settings);
    $vars['body_classes'] = str_replace('sidebar-right', 'second-sidebar',$vars['body_classes']);
  }
  if (!$vars['right'] && $vars['left']) {
    $new_vars = layout_grid_assembler('first_sidebar_layout',$settings);
    $vars['body_classes'] = str_replace('sidebar-left', 'first-sidebar',$vars['body_classes']);
  }
  if (!$vars['right'] && !$vars['left']) {
    $new_vars = layout_grid_assembler('no_sidebars_layout',$settings);
  }
  if($settings['frontpage_layout_checkbox'] == 1 && drupal_is_front_page()){
      $new_vars =  layout_grid_assembler('frontpage_layout',$settings);
  }
  if (is_array($new_vars)) {
    $vars = array_merge($vars, $new_vars);
  }

  return $vars;  
}

function layout_grid_assembler($layout,$settings) {
  $class = array();
  $themes = list_themes();

  // Load values for containers
  if($settings['container_columns'] != 'none' &&  $settings['independent_containers'] != 1){
    $class['page_classes'][] =  $settings['container_columns']; 
  }
  if($settings['container_extras'] != ''){
    $class['page_classes'][] = $settings['container_extras'];
  }
  //if containers are independent add the class container to the main navigation div 
  if($settings['independent_containers'] == 1){
    $class['main_navigation_classes'][] =  ' '. $settings['container_columns']; 
    $class['main_navigation_classes'][] =  ' '. $settings['navigation_extras']; 
  }
  
  // Load values for grids
  if (is_array($settings[$layout]['grids_settings'])) {
    $regions = array('grid', 'prefix', 'suffix', 'push', 'pull');
    foreach ($settings[$layout]['grids_settings'] as $key => $values) {
      foreach ($regions as $data) {
        $class[$key][] = $values[$data] != 0 ?  $data .'_'. $values[$data] : '';
      }
      $class[$key][] = ($values['extras'] != '') ? $values['extras'] : '';
      $class[$key][] = ($values['alpha'] == 1) ? 'alpha' : '';
      $class[$key][] = ($values['omega'] == 1) ? 'omega' : '';
      if($settings['independent_containers'] == 1){
	$container_key = str_replace('_grid','_classes', $key);
	$class[$container_key][] = ($settings['container_columns'] != 'none') ? $settings['container_columns'] : '';
      }
    }
  }
  if (is_array($class)) {
    foreach ($class as $key => $classes) {
      $vars[$key] = implode(' ', $class[$key]);
    }
  }

  return $vars;
}
